from third_party.unicode_to_latex import unicode_to_latex as utl
from aobject.utils import debug_print
from glypher.glypher import interpretations

def latex_to_unicode(latex) :
    latex = str(latex)
    uni = latex
    if latex[0] == '\\' :
        if latex[-1] != '}' :
            latex = latex+' '
        if latex in utl.values() :
            uni = utl.keys()[utl.values().index(latex)]
        else :
            for unit in interpretations.keys() :
                if interpretations[unit]['latex'] == uni :
                    uni = unit
                    break
        debug_print(uni)
    return uni

def unicode_to_latex(uni, ignore_ascii=True) :
    uni = unicode(uni)

    if ignore_ascii :
        uni_ascii = uni.encode('ascii', 'replace')
        new_uni = ''
        for l in range(len(uni_ascii)) :
            # Find non-ascii chars
            if uni_ascii[l] == u'?' and uni[l] != u'?' :
                new_uni += _unicode_to_latex_char(uni[l])
            else :
                new_uni += uni[l]
        uni = new_uni
    else :
        uni = ''.join(map(_unicode_to_latex_char, uni))

    return uni

def _unicode_to_latex_char(uni) :
    if uni in interpretations :
        uni = str(interpretations[uni]['latex'])
    elif uni in utl :
        uni = utl[uni]
    return uni
