function add_video_object(id, filename, n) {
    var div = document.createElement('div');
    div.id = id;
    div.className = 'lantern-video';
    //var el = document.createElement('textarea');
    //el.id = id+'-text';
    var eldiv = document.createElement('div');
    eldiv.id = id+'-div';
    eldiv.className = 'lantern-video-div';
    var eld = document.createElement('video');
    eld.id = id+'-video';
    eld.className = 'lantern-video-video';
    eld.src = filename;

    eldiv.appendChild(eld);
    div.appendChild(eldiv);
    console.log(div.innerHTML);

    eld.style.zIndex = "2";

    lb = get_slot(n);
    lb.appendChild(div);

    return eld;
}
function add_image_object(id, filename, n) {
    var div = document.createElement('div');
    div.id = id;
    div.className = 'lantern-image';
    //var el = document.createElement('textarea');
    //el.id = id+'-text';
    var eldiv = document.createElement('div');
    eldiv.id = id+'-div';
    eldiv.className = 'lantern-image-div';
    eldiv.style.display = 'inline';
    eldiv.style.width = '1px';
    var eld = document.createElement('img');
    eld.id = id+'-img';
    eld.className = 'lantern-image-img';
    eld.src = filename;

    eldiv.appendChild(eld);
    div.appendChild(eldiv);
    console.log(div.innerHTML);

    eld.style.zIndex = "2";

    lb = get_slot(n);
    lb.appendChild(div);

    return eld;
}
function fill_text(id, text)
{
        el = document.getElementById(id);

	if ( el === null )
	    return;

	/* Get the tspan */
        el = el.childNodes[0];

	/* Get the text node */
	el.removeChild(el.childNodes[0]);
	el.appendChild(document.createTextNode(text));

        update();
}

function fill_code(id, code_class, code)
{
	el = document.getElementById(id);
	
	if (el === null )
		return;

	el.innerHTML = "<pre></pre>";
	el.firstChild.className = code_class;
	el.firstChild.innerHTML = code;
	el.saved_code = code;

        update();
}

function fill_html(id, html)
{
	el = document.getElementById(id);
	
	if (el === null )
		return;

	el.innerHTML = html;
	el.saved_html = html;

        update();
}

function get_slot(n)
{
	slots = document.getElementById('slots');
	l = slots.childNodes.length;
	for ( var i = l; i <= n; i++ )
	{
		tr = document.createElement('tr');
		td = document.createElement('td');
		tr.appendChild(td);
		slots.appendChild(tr);
	}
	td = slots.childNodes[n].childNodes[0];
	return td;

}

function add_glancer(id, n)
{
    var div = document.createElement('div');
    div.id = id;
    div.className = 'lantern-glancer';
    //var el = document.createElement('textarea');
    //el.id = id+'-text';
    var eld = document.createElement('div');
    eld.id = id+'-div';
    eld.className = 'lantern-glancer-div';

    div.appendChild(eld);
    eld.onfocus = function() {
	    if (focused) focused.onblur();
	    focused=this;
	    this.style.background = '#99CCFF';
    	};
    eld.onblur = function() {
	    this.style.background = 'none';
	    focused = null;
    	};

    eld.style.zIndex = "2";

    lb = get_slot(n);
    lb.appendChild(div);

    return eld;
}

focused = null;
function add_svg_object(id, n)
{
    var div = document.createElement('div');
    div.id = id;
    div.className = 'lantern-svg';
    var eld = document.createElement('div');
    eld.id = id+'-div';
    eld.className = 'lantern-svg-div';

    div.appendChild(eld);
    eld.style.zIndex = "2";

    lb = get_slot(n);
    lb.appendChild(div);
    return eld;
}
function add_textview(id, n)
{
    var div = document.createElement('div');
    div.id = id;
    div.className = 'lantern-text';
    //var el = document.createElement('textarea');
    //el.id = id+'-text';
    var eld = document.createElement('div');
    eld.id = id+'-div';
    eld.className = 'lantern-text-div';

    div.appendChild(eld);
    //div.appendChild(el);

    //el.onchange = function () {
    //        if (el.value == '')
    //    	    eld.innerHTML = '&nbsp';
    //        else 
    //    	    eld.innerHTML = el.value;
    //        document.location.href = 'lantern:'+id+':text:'+el.value;
    //}
    //el.onkeyup = el.onchange;

    //el.onclick = function() {  };
    //eld.onclick = function() { el.focus(); }

    //el.style.zIndex = "-1";
    eld.style.zIndex = "2";
    //el.style.opacity = '0.0';
    //el.style.position = "absolute";

    lb = get_slot(n);
    lb.appendChild(div);
    //eld.onfocus();
    return eld;
    //el.y = eld.y;
}
function send_html_to_title()
{
            html = document.documentElement.innerHTML;
            html = html.replace(/\\/gi, '\\\\');
            html = html.replace(/\n/gi, '\\n');
            document.title = html;
}
function add_codeview(id, n)
{
    var div = document.createElement('div');
    div.id = id;
    div.className = 'lantern-code';
    //var el = document.createElement('codearea');
    //el.id = id+'-code';
    var eld = document.createElement('div');
    eld.id = id+'-div';
    eld.className = 'lantern-code-div';

    div.appendChild(eld);
    //div.appendChild(el);

    //el.onchange = function () {
    //        if (el.value == '')
    //    	    eld.innerHTML = '&nbsp';
    //        else 
    //    	    eld.innerHTML = el.value;
    //        document.location.href = 'lantern:'+id+':code:'+el.value;
    //}
    //el.onkeyup = el.onchange;

    //el.onclick = function() {  };
    //eld.onclick = function() { el.focus(); }

    //el.style.zIndex = "-1";
    eld.style.zIndex = "2";
    //el.style.opacity = '0.0';
    //el.style.position = "absolute";

    lb = get_slot(n);
    lb.appendChild(div);
    //eld.onfocus();
    return eld;
    //el.y = eld.y;
}
