#include <gtk/gtk.h>
#include <gdk/gdk.h>

char* get_svg_from_clipboard() {
	GtkClipboard *clipboard = gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
	GdkAtom target = gdk_atom_intern("image/svg+xml", FALSE);
	GtkSelectionData* seldat = gtk_clipboard_wait_for_contents(clipboard, target);
	if (seldat == NULL) {
		return "";
	}

	char* data = (char*)seldat->data;

        // Note that guchar is unsigned char
	return data;
}
